import { Component, Input, Output, EventEmitter } from "@angular/core";

import { FieldsetContainer } from "../../formulaire/fieldset-container";
import { SelectEntry } from "../../formulaire/select-entry";

@Component({
    selector: "fieldset-container",
    templateUrl: "./fieldset-container.component.html"
})
export class FieldsetContainerComponent {
    @Input("container")
    private _container: FieldsetContainer;

    /**
     * événément de changement d'état d'un select
     */
    @Output()
    private selectChange = new EventEmitter<SelectEntry>();

    private get title(): string {
        if (this._container == undefined)
            return undefined;
        return this._container.label;
    }

    private get fieldsets() {
        return this._container.fieldsets;
    }

    private addStructure() {
        this._container.addFromTemplate(this._container.templates[0].id);
    }

    /**
     * réception d'un événement d'un select
     */
    private onSelectChanged(val: SelectEntry) {
        this.selectChange.emit(val); // on transmet au parent
    }
}