import { ComputeNodeType } from "jalhyd";

import { Field } from "./field";
import { Dependency } from "./dependency/dependency";
import { DependencyConditionType } from "./dependency/dependency-condition";
import { FormulaireDefinition } from "./formulaire-definition";

export class CheckField extends Field {
    private _value: boolean;

    constructor(nodeType: ComputeNodeType, parentForm: FormulaireDefinition, isTmpl: boolean = false) {
        super(nodeType, parentForm, isTmpl);
        this._value = false;
    }

    public getValue(): boolean {
        return this._value;
    }

    public setValue(val: boolean) {
        this._value = val;
    }

    protected verifyDependency(d: Dependency): boolean {
        throw "CheckField.verifyDependency() : type de condition '" + DependencyConditionType[d.masterCondition.type] + "' non pris en charge";
    }

    public get isValid(): boolean {
        return true;
    }

    /**
     * copie des membres
     */
    protected copyMembers(n: CheckField) {
        super.copyMembers(n);
        n._value = this._value;
    }

    /**
     * crée une nouvelle instance
     */
    protected clone(): CheckField {
        return new CheckField(this.computeNodeType, this.parentForm);
    }

    public parseConfig(json: {}, data?: {}) {
        this._confId = json["id"];
        this.setValue(json["value"] == "true");
    }
}
