import { Dependency } from "./dependency";
import { FormulaireElement } from "../formulaire-element";

/** 
 * dépendance déterminant l'affichage de l'élément esclave
 */
export class ExistenceDependency extends Dependency {
    /**
     * true : l'élément slave est affiché si le master est affiché
     * false : l'élément slave est affiché si le master n'est pas affiché
     */
    // private _direct: boolean;

    public toString() {
        return "existdep\n  " + super.toString();
    }

    public clone(master: FormulaireElement): Dependency {
        return new ExistenceDependency(master, this.masterCondition.clone());
    }
}
