import { Dependency } from "./dependency";
import { FormulaireElement } from "../formulaire-element";
import { ValueDependencyCondition } from "./value-dependency-condition";

/** 
 * dépendance déterminant la valeur de l'élément esclave
 */
export class ValueDependency extends Dependency {
    public slaveValue: any;

    constructor(m: FormulaireElement, masterValue: any) {
        super(m, new ValueDependencyCondition(masterValue));
    }

    public toString() {
        return "valdep\n  " + super.toString() + "\n  slave val " + this.slaveValue;
    }

    public clone(master: FormulaireElement): Dependency {
        return new ValueDependency(master, this.masterCondition.clone());
    }
}
