import { ComputeNodeType } from "jalhyd";

import { FormulaireElement } from "./formulaire-element";
import { FormulaireDefinition } from "./formulaire-definition";
import { ValueDependency } from "./dependency/value-dependency";

export abstract class Field extends FormulaireElement {
    constructor(nodeType: ComputeNodeType, parentForm: FormulaireDefinition, isTmpl: boolean = false) {
        super(nodeType, parentForm, isTmpl);
    }

    public abstract get isValid();

    public abstract getValue(): any;
    public abstract setValue(val: any): void;

    private parse_value_dependencies(json: {}) {
        for (let di in json) {
            let d = json[di];
            let masterField: FormulaireElement = this.parentForm.getFormulaireElementById(d["refid"]);
            if (masterField != undefined) {
                let masterValue = d["refvalue"];
                let dep = new ValueDependency(masterField, masterValue);
                dep.slaveValue = d["value"];
                this._dependencies.push(dep);
            }
            else
                throw new Error(`la dépendance de valeur de '${this.id}' fait référence à un élément inconnu '${d["refid"]}'`);
        }
    }

    public parseDependencies(json: {}) {
        super.parseDependencies(json);

        const dep = json["dep_value"];
        if (dep != undefined)
            this.parse_value_dependencies(dep);
    }
}
