import { NgParameter } from "../formulaire/ngparam";

export abstract class CalculatorResults {
    protected paramLabel(p: NgParameter, displaySymbol: boolean): string {
        let res = "";
        if (displaySymbol)
            res += p.symbol;
        if (p.label != undefined && p.label != "")
            if (p.symbol != p.label || !displaySymbol) {
                if (res.length > 0)
                    res += " : ";
                res += p.label;
            }
        if (p.unit != undefined && p.unit != "")
            res += " (" + p.unit + ")";
        return res;
    }

    /**
     * remet tous les résultats à zero
     */
    public abstract reset();

    /**
     * indique si il existe des résultats à afficher
     */
    public abstract get hasResults(): boolean;
}