import { acSection, Result, ResultElement } from "jalhyd";

import { CalculatorResults } from "./calculator-results";
import { NgParameter } from "../formulaire/ngparam";

export class SectionResults extends CalculatorResults {
    private _results: Object[];

    private _section: acSection;

    constructor() {
        super();
        this.reset();
    }

    public reset() {
        this._section = undefined;
        this._results = [];
    }

    public addResult(v: ResultElement, l: string, drawLabel: string) {
        this._results.push({
            "label": l,
            "value": v,
            "drawLabel": drawLabel
        });
    }

    public get results() {
        return this._results;
    }

    public get section() {
        return this._section;
    }

    public set section(s: acSection) {
        this._section = s;
    }

    public get hasResults(): boolean {
        return this._section != undefined && this._results.length > 0;
    }
}
