import { ParamDomain, ComputeNodeType, ComputeNodeParameters, ParamsEquation, ParamDefinition, ParamDomainValue, ParamCalculability, CalculatorType } from "jalhyd";

import { NgParameter } from "../../formulaire/ngparam";
import { FormulaireDefinition } from "../../formulaire/formulaire-definition";

export class ParamService {
    private createAccuracyParameter(calcType: CalculatorType): ParamDefinition {
        const d = new ParamDomain(ParamDomainValue.INTERVAL, 1e-10, 100);
        const p = new ParamDefinition(calcType, 'Pr', d);
        p.calculability = ParamCalculability.FREE;
        return p;
    }

    public createParameter(calcType: CalculatorType, nodeType: ComputeNodeType, symbol: string, form: FormulaireDefinition, isTmpl = false): NgParameter {
        if (symbol === "Pr")
            var prmDef: ParamDefinition = this.createAccuracyParameter(calcType);
        else
            prmDef = ComputeNodeParameters.getInstance().getComputeNodeParameter(calcType, nodeType, symbol);

        if (prmDef == undefined)
            throw new Error(`ParamService.createParameter() : pas de paramètre '${symbol}' pour la calculette ${CalculatorType[calcType]}/type de noeud ${ComputeNodeType[nodeType]}`);

        return new NgParameter(prmDef.clone(), form, isTmpl);
    }
}
